  <p>Ukupni intenzitet kojim će u sceni biti osvijetljen neki dio površine na položaju \(\vec p\) računa se kao:<br><br>
    <i>ukupni intenzitet = <br>
     &nbsp;&nbsp;&nbsp;&nbsp;intenzitet svjetlosti koju emitira sam materijal +<br>
     &nbsp;&nbsp;&nbsp;&nbsp;globalno ambijentno osvjetljenje scene skalirano koeficijentima reflektiranja ambijentnog osvjetljenja materijala +<br>
     &nbsp;&nbsp;&nbsp;&nbsp;prigušeno ambijentno, difuzno i zrcalno osvjetljenje koje generira svaki izvor.</i>
  </p>

  <p>Razloženo po navedenim dijelovima, slijedi detaljniji način izračuna.</p>

  <p>
    <b>Utjecaj globalnog ambijentnog osvjetljenja</b> računamo kao umnožak globalnog ambijentnog osvjetljenja scene skaliranog koeficijentima reflektiranja ambijentnog osvjetljenja materijala:
    \[I_{GA} \cdot k_{MA}\]
  </p>

  <p>
    <b>Utjecaj ambijentnog osvjetljenja izvora</b> računamo kao prigušeno ambijentno osvjetljenje izvora skalirano koeficijentima reflektiranja ambijentnog osvjetljenja materijala:
    \[f_{\text{atten}} \cdot I_{LA} \cdot k_{MA}\]
  </p>

  <p>
    <b>Utjecaj difuznog osvjetljenja izvora</b> računamo kao prigušeno difuzno osvjetljenje izvora skalirano koeficijentima reflektiranja difuznog osvjetljenja materijala i kosinusom kuta između vektora 
    normale površine \(\vec n\) i vektora od površine prema izvoru (ili vektora smjera ako je homogena koordinata položaja izvora 0, kako je prethodno objašnjeno) \(\vec l\),
    pri čemu to osvjetljenje postoji samo ako je kut pod kojim svjetlost upada na površinu između 0° i 90°, dok je inače 0:
    \[f_{\text{atten}} \cdot I_{LD} \cdot k_{MD} \cdot \max{(cos (\vec l, \vec n), 0)}\]
    Ako su vektori \(\vec n\) i \(\vec l\) jedinični, kosinus kuta odgovara njihovu skalarnom produktu pa možemo pisati:
    \[f_{\text{atten}} \cdot I_{LD} \cdot k_{MD} \cdot \max{(\vec l \cdot \vec n, 0)}\]
    što se često podrazumijeva. Zapamtite, ako vidite ili koristite takav oblik izraza, vektori <b>moraju</b> biti normirani (jedinični).
  </p>

  <p>
    <b>Utjecaj zrcalnog osvjetljenja izvora</b> računamo kao prigušeno zrcalno osvjetljenje izvora skalirano koeficijentima reflektiranja zrcalnog osvjetljenja materijala i kosinusom kuta između vektora 
    reflektiranog svjetla izvora oko normale površine \(\vec r\) i vektora od površine prema promatraču \(\vec v = \vec p_V - \vec p\) podignuto na
    potenciju koja regulira blještavilo <i>n</i> (\(\vec p_V\) je položaj promatrača),
    pri čemu to osvjetljenje postoji samo ako je kut pod kojim svjetlost upada na površinu između 0° i 90° (dakle, ako je \(\vec l \cdot \vec n &gt; 0\), dok je inače 0:
    \[f_{\text{atten}} \cdot I_{LR} \cdot k_{MR} \cdot \max{(cos (\vec r, \vec v), 0)}^n \text{ ako je } \vec l \cdot \vec n &gt; 0 \text{ odnosno 0 inače}\]
    Ako su vektori \(\vec r\) i \(\vec l\) jedinični, kosinus kuta odgovara njihovu skalarnom produktu pa možemo pisati:
    \[f_{\text{atten}} \cdot I_{LR} \cdot k_{MR} \cdot \max{(\vec r \cdot \vec v, 0)}^n \text{ ako je } \vec l \cdot \vec n &gt; 0 \text{ odnosno 0 inače}\]
    što se često podrazumijeva. Zapamtite, ako vidite ili koristite takav oblik izraza, vektori <b>moraju</b> biti normirani (jedinični).
  </p>

  <p>
   Refleksiju vektora \(\vec l\) oko vektora \(\vec n\), ako su oba normalizirana (jedinična), možemo izračunati prema izrazu:
   \[
    \vec r = 2 \cdot (\vec l \cdot \vec n) \cdot \vec n - \vec l.
   \]
  </p>

  <p>
    Ako u sceni imamo <i>J</i> izvora, intenzitet promatrane točke površine bit će određen izrazom:
    \[
      I = I_{GA} \cdot k_{MA} + \sum_{j=1}^{J} \left( 
        I_{ME,j} 
        + \frac{1}{k_{c,j} + k_{l,j} \cdot d_j + k_{q,j} \cdot d_j^2} \cdot \left[
          I_{LA,j} \cdot k_{MA} 
          + I_{LD,j} \cdot k_{MD} \cdot \max{(\vec l_j \cdot \vec n, 0)}
          + I_{LR,j} \cdot k_{MR} \cdot \max{(\vec r_j \cdot \vec v, 0)}^n
        \right]
      \right)
    \]
    gdje se prigušenje koristi samo kod točkastih izvora u kojem slučaju se udaljenost računa kao \(d_j = \|\vec p_{L,j} - \vec p\|\) (inače se postavlja na 1) a zrcalna komponenta
    postoji samo ako je \(\vec l_j \cdot \vec n &gt; 0\) dok se inače postavlja na 0.
  </p>

  <p>
    U novijim inačicama OpenGL-a korisnici mogu izravno programirati sjenčare vrhova i fragmenata (engl.
    <i>vertex shader</i>, <i>fragment shader</i>). Time je ovakva preddefinirana struktura (koja još dodatno 
    uključuje reflektorska svjetla koja smo ovdje izostavili) uklonjena i korisnici sami mogu pisati model
    osvjetljenja kakav žele. Često se, međutim, i dalje koristi upravo ovakav model.
  </p>

  <p>
    Primjetite također da u opisanom modelu u cijelosti ignoriramo interakciju objekata u sceni.
    U stvarnosti, ako se jedan objekt nalazi između drugog objekta i izvora svjetlosti, taj će drugi objekt
    biti zasjenjen. Ovdje opisani model to ne uzima u obzir pa je za postizanje realističnijih prikaza
    potrebno na odgovarajući način proširiti model.
  </p>
